<template>
	<div class="FieldsView">
		<fields-view-controls-mobile v-if="$vuetify.breakpoint.smAndDown" />
		<fields-view-controls v-else />
		<v-divider v-if="$vuetify.breakpoint.lgAndUp"></v-divider>
		<fields-list v-if="$vuetify.breakpoint.mdAndDown" />
		<div v-else class="FieldsView-splitContainer">
			<div class="text-center py-6" v-if="isLoading">
				<v-progress-circular :size="50" indeterminate color="primary"></v-progress-circular>
			</div>
			<template v-else>
				<div class="FieldsView-splitContainer-left">
					<fields-list v-if="$vuetify.breakpoint.lgAndDown" />
					<fields-table v-else />
				</div>
				<div class="FieldsView-splitContainer-right">
					<fields-view-map v-if="isLoaded" />
				</div>
			</template>
		</div>
	</div>
</template>

<script lang="ts">
import { defineComponent, computed } from '@vue/composition-api';
import FieldsViewMap from './FieldsViewMap/FieldsViewMap.vue';
import FieldsList from './FieldsList/FieldsList.vue';
import FieldsTable from './FieldsTable/FieldsTable.vue';
import FieldsViewControls from './FieldsViewControls/FieldsViewControls.vue';
import FieldsViewControlsMobile from './FieldsViewControls/FieldsViewControlsMobile.vue';
import { useAllResources } from '@/store/modules/resources';
import { useGroups } from '@/store/modules/group';

export default defineComponent({
	components: {
		FieldsViewMap,
		FieldsViewControls,
		FieldsViewControlsMobile,
		FieldsTable,
		FieldsList,
	},
	setup(_, { root }) {
		const { isLoaded: areResourcesLoaded, isLoading: areResourcesLoading } = useAllResources(root.$store);
		const { isLoaded: areGroupsLoaded, isLoading: areGroupsLoading } = useGroups(root.$store);
		const isLoading = computed(() => areGroupsLoading.value || areResourcesLoading.value);
		const isLoaded = computed(() => areGroupsLoaded.value && areResourcesLoaded.value);

		return {
			isLoaded,
			isLoading,
		};
	},
});
</script>

<style>
.FieldsView {
	margin: 0 auto;
	width: 100%;
	height: 100%;
	display: flex;
	flex-direction: column;
}

.FieldsView-splitContainer {
	display: flex;
	flex-direction: row;
	height: 100%;
	min-height: 0;
	justify-content: center;
}

.FieldsView-splitContainer-left,
.FieldsView-splitContainer-right {
	width: 50%;
	height: 100%;
}

@media (max-width: 823px) {
	.FieldsView {
		overflow-y: auto;
	}
}
</style>
